/**
 * @file main.cpp
 * @brief 
 */


#include <stdexcept>

#include "TSPSolver.h"

// error status and messagge buffer
int status;
char errmsg[255];


int main (int argc, char const *argv[])
{
	try
	{
		if (argc < 4) throw std::runtime_error("usage: ./main filename.dat tabulength maxiter");
		int tabuLength = atoi(argv[2]);
		int maxIter    = atoi(argv[3]);
		TSP tspInstance;
		tspInstance.read(argv[1]);
		TSPSolution aSolution(tspInstance);
		TSPSolver tspSolver;
		tspSolver.initRnd(aSolution);
		
		TSPSolution bestSolution(tspInstance);
		tspSolver.solve(tspInstance,aSolution,tabuLength,maxIter,bestSolution);
		
		std::cout << "FROM solution: "; 
		aSolution.print();
		std::cout << "(value : " << tspSolver.evaluate(aSolution,tspInstance) << ")\n";
		std::cout << "TO   solution: "; 
		bestSolution.print();
		std::cout << "(value : " << tspSolver.evaluate(bestSolution,tspInstance) << ")\n";
		
	}
	catch(std::exception& e)
	{
		std::cout << ">>>EXCEPTION: " << e.what() << std::endl;
	}
	return 0;
}
